<script setup>
import AuthenticatedLayout from '@/Layouts/AuthenticatedLayout.vue';

import { Head, Link, useForm } from '@inertiajs/vue3';
import { showFlashMessage } from '@/global_func.js';




</script>

<template>
    <Head title="Dashboard" />

    <AuthenticatedLayout :user="user">
        <div class="container-fluid">

            <!-- Page Heading -->
            <h1 class="h3 mb-2 text-gray-800">Dashboard</h1>
            <p class="mb-4">Overview data pesanan dan lain-lain.</p>

            <template v-if="user.role == 'admin'">
                <!-- Content Row -->
                <div class="row">


                    <!-- Pemasukan (perbulan) Card Example -->
                    <div class="col-xl-6 col-md-6 mb-4">
                        <div class="card border-0 border-left-success   py-2">
                            <div class="card-body">
                                <div class="row no-gutters align-items-center">
                                    <div class="col mr-2">
                                        <div class="text-xs font-weight-bold text-success text-uppercase mb-1">
                                            Pemasukan (total)</div>
                                        <div class="h5 mb-0 font-weight-bold text-gray-800">Rp. {{
                                            Number(calculateTotalLunas()).toLocaleString() }}</div>
                                    </div>
                                    <div class="col-auto">
                                        <i class="fas fa-dollar-sign fa-2x text-gray-300"></i>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>

                    <!-- Pemasukan (perbulan) Card Example -->
                    <div class="col-xl-3 col-md-6 mb-4">
                        <div class="card border-0 border-left-info   py-2">
                            <div class="card-body">
                                <div class="row no-gutters align-items-center">
                                    <div class="col mr-2">
                                        <div class="text-xs font-weight-bold text-info text-uppercase mb-1">Pelanggan
                                        </div>
                                        <div class="row no-gutters align-items-center">
                                            <div class="col-auto">
                                                <div class="h5 mb-0 mr-3 font-weight-bold text-gray-800">{{
                                                    pesanan.length }} </div>
                                            </div>
                                            <div class="col">
                                                <div class="progress progress-sm mr-2">
                                                    <div class="progress-bar bg-info" role="progressbar" style="width: 50%"
                                                        aria-valuenow="50" aria-valuemin="0" aria-valuemax="100"></div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="col-auto">
                                        <i class="fas fa-clipboard-list fa-2x text-gray-300"></i>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>

                    <!-- Pending Requests Card Example -->
                    <div class="col-xl-3 col-md-6 mb-4">
                        <div class="card border-0 border-left-warning   py-2">
                            <div class="card-body">
                                <div class="row no-gutters align-items-center">
                                    <div class="col mr-2">
                                        <div class="text-xs font-weight-bold text-warning text-uppercase mb-1">
                                            Pesanan</div>
                                        <div class="h5 mb-0 font-weight-bold text-gray-800">{{ pesanan.length }}</div>
                                    </div>
                                    <div class="col-auto">
                                        <i class="fas fa-comments fa-2x text-gray-300"></i>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="row">
                    <div class="col-sm-12">
                        <div class="card border-0 mb-4">
                            <div class="card-header py-3 bg-main d-flex justify-content-between align-items-center">
                                <h6 class="m-0 font-weight-bold text-white">Data Pesanan</h6>
                                <div class="d-flex">
                                    <input type="date" class="form-control ml-2" v-model="tgl_awal">
                                    <input type="date" class="form-control ml-2" v-model="tgl_akhir">
                                    <button @click="filterByDate()" class="btn btn-primary ml-2">Filter</button>
                                    <Link href="/dashboard" class="btn btn-info ml-2"> <i class="fas fa-sync"></i></Link>
                                </div>
                            </div>
                            <div class="card-body">
                                <div class="table-responsive">
                                    <table class="table table-bordered" id="dataTable" width="100%" cellspacing="0">
                                        <thead>
                                            <tr>
                                                <th>#</th>
                                                <td>Tanggal</td>
                                                <th>Nama pembeli</th>
                                                <th>Produk</th>
                                                <th>Total</th>
                                                <th>Piutang</th>
                                                <th>Lunas</th>
                                                <th>Pembayaran</th>
                                                <th>#</th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                            <tr v-for="pesanan in pesanan">
                                                <td class="align-middle">{{ pesanan.id }}</td>
                                                <td class="align-middle">{{ formattedCreatedAt(pesanan.created_at) }}</td>
                                                <td class="align-middle">{{ pesanan.pelanggan.nama }}</td>
                                                <td>
                                                    <table>
                                                        <tr>
                                                            <td>Nama produk</td>
                                                            <td>jumlah</td>
                                                            <td>harga</td>
                                                        </tr>
                                                        <tr v-for="produk in pesanan.produk">
                                                            <td>{{ produk.nama }}</td>
                                                            <td>{{ produk.jumlah }} {{ produk.satuan }}</td>
                                                            <td> Rp. {{
                                                                Number(calculateSubtotal(produk)).toLocaleString()
                                                            }}</td>
                                                        </tr>
                                                    </table>
                                                </td>
                                                <td class="align-middle">Rp. {{ Number(total(pesanan)).toLocaleString() }}
                                                </td>
                                                <td class="align-middle">
                                                    Rp. {{ Number(total(pesanan) -
                                                        sumJumlahYangDibayar(pesanan.pembayaran)).toLocaleString() }}
                                                </td>
                                                <td class="align-middle">
                                                    Rp. {{ Number(sumJumlahYangDibayar(pesanan.pembayaran)).toLocaleString()
                                                    }}
                                                </td>
                                                <td class="align-middle">
                                                    <template
                                                        v-if="sumJumlahYangDibayar(pesanan.pembayaran) >= total(pesanan)">
                                                        <span class="badge badge-success">lunas</span>
                                                    </template>
                                                    <template v-else>
                                                        <span class="badge badge-danger">belum lunas</span>
                                                    </template>
                                                </td>
                                                <td class="align-middle">
                                                    <Link :href="'/pesanan/' + pesanan.id" class="badge badge-primary">
                                                    Detail
                                                    </Link>
                                                </td>
                                            </tr>
                                        </tbody>
                                    </table>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </template>
            <template v-else>
                <div class="row">
                    <div class="col-sm-12">
                        <div class="card">
                            <div class="card-body d-flex justify-content-center align-items-center flex-column">
                                <img src="/assets/img/logo.png" width="250">
                                <h5>Selamat datang di Percetakan Alif</h5>
                            </div>
                        </div>
                    </div>
                </div>
            </template>



        </div>


    </AuthenticatedLayout>
</template>

<script>



export default {
    props: {
        user: Object,
        users: Object,
        pesanan: Object,
    },
    computed: {

        // Calculate total for all products in all orders

    },
    methods: {
        formattedCreatedAt(date) {
            return date.substring(0, 10); // or this.created_at.slice(0, 10);
        },
        filterByDate() {
            document.location.href = '/dashboard/' + this.tgl_awal + '/' + this.tgl_akhir;
        },
        calculateTotalLunas() {
            let totalLunas = 0;
            this.pesanan.forEach(pesanan => {
                if (this.sumJumlahYangDibayar(pesanan.pembayaran) >= this.total(pesanan)) {
                    totalLunas += this.total(pesanan);
                }
            });
            return totalLunas;
        },
        total(pesanan) {
            let total = 0;
            pesanan.produk.forEach(product => {
                total += product.jumlah * product.harga_satuan;
            });
            return total;
        },
        sumJumlahYangDibayar(data) {
            if (!data || data.length === 0) {
                return 0;
            }

            return data.reduce((total, item) => total + item.jumlah_yang_dibayar, 0);
        },
        calculateSubtotal(row) {
            // Calculate subtotal for a row

            return row.jumlah * row.harga_satuan;
        },
    }, mounted() {
        // Initialize DataTables
        $('#dataTable').DataTable({
            // DataTables configuration options
        });
    }
}
</script>
